<?php
/*
Plugin Name: SEO Blogger to Wordpress using 301 Redirection
Plugin URI: http://suhastech.com/seo-blogger-to-wordpress
Description: This plugin will 301 redirect all incoming traffic from your Blogger account to your newly setup Wordpress account. Please read the documentation at suhastech.com/seo-blogger-to-wordpress before you continue.
Version: 0.1.3
Author: Suhas Sharma
Author URI: http://suhastech.com
*/

/*  Copyright 2010 Suhas Sharma <sharma@suhastech.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


/**
 * Main action handler
 *
 * @package SEO Blogger to Wordpress
 * @since 0.1
 *
 * redirects all incoming traffic from your Blogger account to your newly setup Wordpress account.
 */
function suhas_generator() {
        add_management_page('SEO Blogger to Wordpress', 'SEO Blogger to Wordpress', 'manage_options',
            __FILE__, 'admin_page');
    }
	
	function admin_page() {
	?>
	<a href="http://suhastech.com/donate">A lot of work has gone in to writing this plugin, If you want, you can donate some money for future development. <img src="http://www.paypal.com/en_US/i/btn/btn_donate_LG.gif" /></a>
	<h3>Please read the <a href="http://suhastech.com/seo-blogger-to-wordpress">documentation</a> before you continue.</h3>

	<h2>Blogger Classic Template</h2>
	<p>This is for yourblog.blogspot.com domain users only. Goto Blogger Dashboard --> Design --> Layout --> Edit HTML. Switch to Classic Template. Copy the generated template to the text area. Save.</p>
	<form method="get" action="tools.php">
    <input type="hidden" name="page" value="<?php echo $_GET['page'];?>" />
	Your current Wordpress URL: <input type="text" name="url" value="<?php echo home_url('/'); ?>" />
	<input type="hidden" name="blogspot" value="1" />
	<input type="submit" value="Generate" />
	</form>
	<hr />
	<h2>Downloading Images</h2>
	<p>Click on 'Download' to all the images from the Picasa server to your server. By default, it'll be saved in /wp-content/uploads/images. By doing this, automatic thumbnails advertised by themes will now work.</p>
	<p>Please note that, this will take a considerable amount of time. You can close this anytime you want, the next time you press 'Download", it'll start from the same place it stopped. </p>
	<p>"Download Successful" marks the end of the process.</p>
	<form method="get" action="tools.php">
    <input type="hidden" name="page" value="<?php echo $_GET['page'];?>" />
	<input type="hidden" name="magic" value="1" />
	<input type="submit" value="Download" />
	</form>
	
	<?php
	if (isset($_GET['magic']))
	{
	global $post;
	include('lib.php');
$wp_query = new WP_Query( 'posts_per_page=-1');
if ( $wp_query->have_posts() ) : while ( $wp_query->have_posts() ) : $wp_query->the_post(); 
if (!(get_post_meta($post->ID, "blogger_images") == "1"))
{
$new_content = get_the_content();

if(!function_exists('imagecreatetruecolor')) {
    displayError('GD Library Error: imagecreatetruecolor does not exist - please contact your webhost and ask them to install the GD library');
} else {
$html = str_get_html($new_content);
foreach($html->find('img') as $element) {
   $original = $element->src;
    $replace = explode("?", $original);
    $final = explode("/", $replace[0]);
	$filename = str_replace('%', '', end($final));
	$path = ABSPATH."wp-content/uploads/images/";
    $image = new Download_Image;
    $image->source_image = $replace[0];
    $image->new_image_name = $filename;
    $image->save_to_folder = $path;
if (!is_dir($path))
{
    mkdir($path);
} 
if (@GetImageSize($replace[0])) {
    $get = $image->make(); 
}

	$new_content = str_replace($original, 'wp-content/uploads/images/'.$filename ,$new_content);
   
}
}

echo "Images downloaded from '".$post->post_title."'<br />";

$my_post = array();
  $my_post['ID'] = $post->ID;
   if ($new_content[0] == ">")
  {      
      $my_post['post_content'] = substr($new_content, 1);
  } else  
  {
  $my_post['post_content'] = $new_content;
  }
  if ($post->post_title[0] == ">" )
  {
  $my_post['post_title'] = substr($post->post_title, 1);
  } else
  {
  $my_post['post_title'] = $post->post_title;  
  }

  wp_update_post( $my_post );
	add_post_meta($post->ID, 'blogger_images', '1', true);
	echo "Post Updated ".$post->ID."<br />";
	}


endwhile;
endif;

echo "<p><b>Download Successful</b></p><p>This plugin adds some post meta data to identify downloaded images. Click on 'Clear Temporary Settings' to delete them.</p>".'<form method="get" action="tools.php"><input type="hidden" name="page" value="'.$_GET['page'].'" /><input type="hidden" name="clear" value="1" /><input type="submit" value="Clear Temporary Settings" /></form>';
	}
	if (isset($_GET['clear']))
	{
	global $post;
	$allposts = get_posts('numberposts=-1&post_type=post&post_status=any');

  foreach( $allposts as $postinfo) {
    delete_post_meta($postinfo->ID, 'blogger_images');
  }

echo "<b>Temporary Information Deleted</b>";
	}
	if (isset($_GET['blogspot']))
	{
	if (isset($_GET['url']))
	{
	$site = $_GET['url'];
	$ult1 = 'http://'.$site.'/';

$ult2 = str_replace('http://http://', 'http://', $ult1);
$ult3  = str_replace('//', '/', $ult2);
$ult4 = str_replace('http:/', 'http://', $ult3);
if (!(preg_match("/blogspot.com/i", $ult )) && !(preg_match("/www/i", $ult ))   )
{
$ult5 = str_replace('http://', 'http://www.', $ult4);
$ult = str_replace('http://www.www.', 'http://www.', $ult5);

}
else {
$ult = $ult4;
}
if ((preg_match("/blogspot.com/i", $ult ))   )
{

$ult = str_replace('http://www.', 'http://', $ult4);
}

echo '<textarea cols="80" rows="20"><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en" dir="<$BlogLanguageDirection$>"><head> <title>  <$BlogPageTitle$> </title> <script type="text/javascript"> <MainorArchivePage>window.location.href=".$ult."</MainOrArchivePage>  <Blogger><ItemPage>window.location.href="'.$ult.'?blogger=<$BlogItemPermalinkURL$>"</ItemPage></Blogger> </script> <MainPage><link rel="canonical" href="'.$ult.'" /></MainPage>  <Blogger><ItemPage><link rel="canonical" href="'.$ult.'blogger/?q=<$BlogItemPermalinkURL$>" /></ItemPage></Blogger></head><body> <div style="border: #ccc 1px solid; background: #eee; padding: 20px; margin: 80px;">  <p>This page has moved to a new address.</p>   <h1>     <MainOrArchivePage><a href="'.$ult.'"><$BlogTitle$></a></MainOrArchivePage>     <Blogger>       <ItemPage><a href="'.$ult.'?blogger=<$BlogItemPermalinkURL$>"><$BlogItemTitle$></a></ItemPage>     </Blogger>    </h1>  </div>  </body>  </html></textarea>';

} else { echo "No URL specified";}
	
	}
	}
 
function suhas_blogger() {
global $wpdb;
	if ( !is_404() )
		return;

        $req_uri = $_SERVER['REQUEST_URI'];	
        $url = explode("?", $req_uri);	
        $res = $wpdb->get_results("SELECT post_id FROM $wpdb->postmeta WHERE meta_key = 'blogger_permalink' AND meta_value = '$url[0]'");
if(isset($res[0]->post_id))	
{
wp_redirect(get_permalink($res[0]->post_id), 301 );
}
else
{
return;
}
	exit();
}

function suhas_blogspot() {
global $wpdb;
 $old_url = $_GET['blogger'];

 if ($old_url != "") {
 
   $permalink = explode("blogspot.com", $old_url);
   $url = explode("?", $permalink[1]);
   $res = $wpdb->get_results("SELECT post_id FROM $wpdb->postmeta WHERE meta_key = 'blogger_permalink' AND meta_value = '$url[0]'");
if(isset($res[0]->post_id))	
{
wp_redirect(get_permalink($res[0]->post_id), 301 );
}
else
{
return;
}

 }
exit();
}

add_action('admin_menu', 'suhas_generator');
add_action( 'template_redirect', 'suhas_blogger' );
if ( isset( $_GET['blogger'] ) )
add_action( 'template_redirect', 'suhas_blogspot' );
?>
